#include <stdio.h>
#include "seccomp-bpf.h"
#include <sys/mman.h>
#include <assert.h>

void install_syscall_filter()
{
    // A seccomp filter is a sandbox-like structure. Here, the code will only allow the open, read, exit, and nanosleep system call.
    // This means you can read the flag, but no way you can exfiltrate the flag!
    struct sock_filter filter[] = {
        VALIDATE_ARCHITECTURE,
        EXAMINE_SYSCALL,
        ALLOW_SYSCALL(open),
        ALLOW_SYSCALL(read),
        ALLOW_SYSCALL(exit),
        KILL_PROCESS,
    };
    struct sock_fprog prog = {
        .len = (unsigned short)(sizeof(filter)/sizeof(filter[0])),
        .filter = filter,
    };

    assert(prctl(PR_SET_NO_NEW_PRIVS, 1, 0, 0, 0) == 0);

    assert(prctl(PR_SET_SECCOMP, SECCOMP_MODE_FILTER, &prog) == 0);
}

int main(){
    setvbuf(stdin, NULL, 2, 0);
    setvbuf(stdout, NULL, 2, 0);
    void *buf = mmap(0x13371337000, 0x4000, PROT_READ|PROT_WRITE|PROT_EXEC, MAP_SHARED|MAP_ANONYMOUS, -1, 0);

    puts("I heard you had some shellcode for me...");
    fgets(buf, 0x4000, stdin);
    puts("Nice! Executing now!");
    install_syscall_filter();
    (*(void(*)()) buf)(); // jumping to shellcode!
}
